## com.vividsolutions.jts.index.chain
Class MonotoneChain

    java.lang.Object
      com.vividsolutions.jts.index.chain.MonotoneChain

public class MonotoneChain
extends java.lang.Object

Monotone Chains are a way of partitioning the segments of a linestring to allow for fast searching of intersections. They have the following properties:

1. the segments within a monotone chain never intersect each other
2. the envelope of any contiguous subset of the segments in a monotone chain is equal to the envelope of the endpoints of the subset.

Property 1 means that there is no need to test pairs of segments from within the same monotone chain for intersection.

Property 2 allows an efficient binary search to be used to find the intersection points of two monotone chains. For many types of real-world data, these properties eliminate a large number of segment comparisons, producing substantial speed gains.

One of the goals of this implementation of MonotoneChains is to be as space and time efficient as possible. One design choice that aids this is that a MonotoneChain is based on a subarray of a list of points. This means that new arrays of points (potentially very large) do not have to be allocated.

MonotoneChains support the following kinds of queries:

- Envelope select: determine all the segments in the chain which intersect a given envelope
- Overlap: determine all the pairs of segments in two chains whose envelopes overlap

This implementation of MonotoneChains uses the concept of internal iterators to return the resultsets for the above queries. This has time and space advantages, since it is not necessary to build lists of instantiated objects to represent the segments returned by the query. However, it does mean that the queries are not thread-safe.

Version:
  1.7

Constructor Summary
`MonotoneChain(Coordinate[] pts, int start, int end, java.lang.Object context)`

Method Summary
`void` `computeOverlaps(MonotoneChain mc, MonotoneChainOverlapAction mco)`
`java.lang.Object` `getContext()`
`Coordinate[]` `getCoordinates()` Return the subsequence of coordinates forming this chain.
`int` `getEndIndex()`
`Envelope` `getEnvelope()`
`int` `getId()`
`void` `getLineSegment(int index, LineSegment ls)`
`int` `getStartIndex()`
`void` `select(Envelope searchEnv, MonotoneChainSelectAction mcs)` Determine all the line segments in the chain whose envelopes overlap the searchEnvelope, and process them
`void` `setId(int id)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MonotoneChain

    public MonotoneChain(Coordinate[] pts,
                         int start,
                         int end,
                         java.lang.Object context)

Method Detail

### setId

    public void setId(int id)

### getId

    public int getId()

### getContext

    public java.lang.Object getContext()

### getEnvelope

    public Envelope getEnvelope()

### getStartIndex

    public int getStartIndex()

### getEndIndex

    public int getEndIndex()

### getLineSegment

    public void getLineSegment(int index,
                               LineSegment ls)

### getCoordinates

    public Coordinate[] getCoordinates()

  Return the subsequence of coordinates forming this chain. Allocates a new array to hold the Coordinates

### select

    public void select(Envelope searchEnv,
                       MonotoneChainSelectAction mcs)

  Determine all the line segments in the chain whose envelopes overlap the searchEnvelope, and process them

### computeOverlaps

    public void computeOverlaps(MonotoneChain mc,
                                MonotoneChainOverlapAction mco)